﻿-- Author      : Nogarder
-- Create Date : 2013/6/9 16:33:21
local NPA_Color_GetColorByPower=NPA.Color.GetColorByPower
local NPA_NamePlateDataParser_AddElements=NPA.NamePlateDataParser.AddElements

local NPA_NamePlateModuleManager_ZipModule=NPA.NamePlateModuleManager.ZipModule
local NPA_NamePlateModuleManager_UnzipModule=NPA.NamePlateModuleManager.UnzipModule

local NPA_FrameMacro_SetFrameTimer=NPA.FrameMacro.SetFrameTimer

local NPA_NumberManager_SetNumber=NPA.NumberManager.SetNumber
local NPA_NumberManager_SetNumberColor=NPA.NumberManager.SetNumberColor

local NPA_BarManager_SetBarGroupColor=NPA.BarManager.SetBarGroupColor
local NPA_BarManager_SetBarGroup=NPA.BarManager.SetBarGroup
--
NPA.NamePlateModuleManager.RegisterDataModule("BarGroup","Power",function(framedata,bargroupframe,setting)
	--add event elements
 	--hook name update
	NPA_NamePlateDataParser_AddElements(framedata,bargroupframe,"Power_Updated",function(framedata,unitdata)
		if(unitdata.PowerUpdated)then
			NPA_BarManager_SetBarGroup(bargroupframe,(unitdata.Power or 0)/(unitdata.PowerMax or 1))
			if(setting.ColorMode==9)then
				local color=NPA_Color_GetColorByPower(unitdata.PowerType)
				NPA_BarManager_SetBarGroupColor(bargroupframe,color)
			end
			--set timer
			NPA_FrameMacro_SetFrameTimer(bargroupframe,unitdata.PowerUpdated,unitdata.PowerUpdated+1,
				function(nTime,data)
					--update alpha
					local percent=(data.EndTime-nTime)/data.Length
					bargroupframe:SetAlpha(setting.Alpha*percent)
				end,
				function()
					--hide when time out
					NPA_NamePlateModuleManager_ZipModule(bargroupframe)
				end)
			NPA_NamePlateModuleManager_UnzipModule(bargroupframe)
		else
			NPA_NamePlateModuleManager_ZipModule(bargroupframe)
		end
	end)
end)
NPA.NamePlateModuleManager.RegisterDataModule("Number","Power",function(framedata,numberframe,setting)
	--add event elements
 	--hook name update
	NPA_NamePlateDataParser_AddElements(framedata,numberframe,"Power_Updated",function(framedata,unitdata)
		if(unitdata.PowerUpdated)then
			--prevent it to be zero
			NPA_NumberManager_SetNumber(numberframe,unitdata.Power or 0,(unitdata.PowerMax or 1)+1)
			if(setting.ColorMode==9)then
				local color=NPA_Color_GetColorByPower(unitdata.PowerType)
				NPA_NumberManager_SetNumberColor(numberframe,color)
			end
			--set timer
			NPA_FrameMacro_SetFrameTimer(numberframe,unitdata.PowerUpdated,unitdata.PowerUpdated+1,
				function(nTime,data)
					--update alpha
					local percent=(data.EndTime-nTime)/data.Length
					numberframe:SetAlpha(setting.Alpha*percent)
				end,
				function()
					--hide when time out
					NPA_NamePlateModuleManager_ZipModule(numberframe)
				end)
			NPA_NamePlateModuleManager_UnzipModule(numberframe)
		else
			NPA_NamePlateModuleManager_ZipModule(numberframe)
		end
	end)
end)
--
NPA.NamePlateModuleManager.RegisterDataModule("TextureGroup","Power",function(framedata,textureframe,setting)
	NPA_NamePlateDataParser_AddElements(framedata,textureframe,"Power_Updated",function(framedata,unitdata)
		if(unitdata.PowerUpdated)then
			--set timer
			NPA_FrameMacro_SetFrameTimer(textureframe,unitdata.PowerUpdated,unitdata.PowerUpdated+1,
				function(nTime,data)
					--update alpha
					local percent=(data.EndTime-nTime)/data.Length
					textureframe:SetAlpha(setting.Alpha*percent)
				end,
				function()
					--hide when time out
					NPA_NamePlateModuleManager_ZipModule(textureframe)
				end)
			NPA_NamePlateModuleManager_UnzipModule(textureframe)
		else
			NPA_NamePlateModuleManager_ZipModule(textureframe)
		end
	end)
end)